ifndef _CBButton_
_CBButton_ equ 1

; --=====================================================================================--
; CBButton CLASS
; --=====================================================================================--
; Built by NaN's Object Class Creator
;  Sept 1, 2001
;
; By NaN ( jaymeson@hotmail.com )
; http://nan32asm.cjb.net
;
; --=====================================================================================--
; CLASS METHOD PROTOS
; --=====================================================================================--
   CBButton_Init    PROTO  :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD

; --=====================================================================================--
; FUNCTION POINTER PROTOS
; --=====================================================================================--
   CBBu_destructorPto    TYPEDEF  PROTO  :DWORD 
   CBBu_getHandlePto    TYPEDEF  PROTO  :DWORD
   CBBu_getRectPto    TYPEDEF  PROTO  :DWORD
   CBBu_setButtonDownPto    TYPEDEF  PROTO  :DWORD, :DWORD
   CBBu_setButtonUpPto    TYPEDEF  PROTO  :DWORD, :DWORD
   CBBu_DrawItemPto      TYPEDEF   PROTO  :DWORD, :DWORD

; --=====================================================================================--
; CLASS STRUCTURE
; --=====================================================================================--
   CLASS CBButton, CBBu
      CMETHOD destructor  
      CMETHOD DrawItem
      CMETHOD getHandle   
      CMETHOD getRect     
      CMETHOD setButtonDown
      CMETHOD setButtonUp
      hButtonDown     dd    ?
      hButtonUp     dd    ?
      hWnd     dd    ?
      Rect     RECT <>
   CBButton ENDS

.data

   BEGIN_INIT 
      dd offset CBBu_destructor_Funct
      dd offset CBBu_DrawItem_Funct
      dd offset CBBu_gethWnd_Funct
      dd offset CBBu_getRect_Funct
      dd offset CBBu_sethButtonDown_Funct
      dd offset CBBu_sethButtonUp_Funct
      dd NULL
      dd NULL
      dd NULL
      dd 0, 0, 0, 0
   END_INIT

 CBBu_Class db "button",0
 
 
.code
; --=====================================================================================--
; CLASS CONSTRUCTOR
; --=====================================================================================--
CBButton_Init  PROC uses edi esi lpTHIS:DWORD, hInst:DWORD, hWnd:DWORD, xP:DWORD, yP:DWORD, \
                                               wx:DWORD, wy:DWORD, BitDown:DWORD, BitUp:DWORD
   SET_CLASS CBButton
   SetObject edi, CBButton

   invoke CreateWindowEx, NULL, addr CBBu_Class, NULL, \
                          BS_OWNERDRAW or WS_CHILD or WS_VISIBLE, \
                          xP, yP, wx, wy, hWnd, NULL, hInst, NULL
   mov [edi].hWnd, eax
   
   invoke LoadBitmap, hInst, BitDown
   mov [edi].hButtonDown, eax
   
   invoke LoadBitmap, hInst, BitUp
   mov [edi].hButtonUp, eax
   
   lea eax, [edi].Rect
   mov ecx, xP
   mov [eax], ecx
   add eax, 4
   mov ecx, yP
   mov [eax], ecx
   add eax, 4
   mov ecx, wx
   mov [eax], ecx
   add eax, 4
   mov ecx, wy
   mov [eax], ecx

   ReleaseObject edi
   ret
CBButton_Init ENDP

; --=====================================================================================--
; destructor METHOD BEHAVIOR
; --=====================================================================================--
CBBu_destructor_Funct  PROC uses edi lpTHIS:DWORD 
   SetObject edi, CBButton

   invoke DeleteObject, [edi].hButtonUp
   invoke DeleteObject, [edi].hButtonDown
   invoke DestroyWindow, [edi].hWnd
   
   ReleaseObject edi
   ret
CBBu_destructor_Funct  ENDP

; --=====================================================================================--
; Draw Item METHOD BEHAVIOR
; --=====================================================================================--
CBBu_DrawItem_Funct  PROC uses edi esi lpTHIS:DWORD, A:DWORD
   LOCAL hdc   :DWORD
   SetObject edi, CBButton
     mov esi, A
     mov eax, (DRAWITEMSTRUCT PTR [esi]).hwndItem
     .if( eax == [edi].hWnd )
        invoke CreateCompatibleDC, (DRAWITEMSTRUCT PTR [esi]).hdc
        mov hdc, eax
        
        mov eax, (DRAWITEMSTRUCT PTR [esi]).itemState
        and eax, ODS_SELECTED
        .if( eax )
          invoke SelectObject, hdc, [edi].hButtonDown
        .else
          invoke SelectObject, hdc, [edi].hButtonUp
        .endif
        
        invoke BitBlt, (DRAWITEMSTRUCT PTR [esi]).hdc, \
                       (DRAWITEMSTRUCT PTR [esi]).rcItem.left, \
                       (DRAWITEMSTRUCT PTR [esi]).rcItem.top, \
                       (DRAWITEMSTRUCT PTR [esi]).rcItem.right, \
                       (DRAWITEMSTRUCT PTR [esi]).rcItem.bottom, \
                       hdc, NULL, NULL, SRCCOPY
        invoke DeleteDC, hdc
     .endif
   ReleaseObject edi
   ret
CBBu_DrawItem_Funct  ENDP

; --=====================================================================================--
; gethWnd METHOD BEHAVIOR
; --=====================================================================================--
CBBu_gethWnd_Funct  PROC uses edi lpTHIS:DWORD
   SetObject edi, CBButton

   mov eax, [edi].hWnd

   ReleaseObject edi
   ret
CBBu_gethWnd_Funct  ENDP

; --=====================================================================================--
; getRect METHOD BEHAVIOR
; --=====================================================================================--
CBBu_getRect_Funct  PROC uses edi lpTHIS:DWORD
   SetObject edi, CBButton

   lea eax, [edi].Rect

   ReleaseObject edi
   ret
CBBu_getRect_Funct  ENDP

; --=====================================================================================--
; sethButtonDown METHOD BEHAVIOR
; --=====================================================================================--
CBBu_sethButtonDown_Funct  PROC uses edi lpTHIS:DWORD, DATA:DWORD
   SetObject edi, CBButton
   
   mov eax, [edi].hButtonDown
   push eax
   mov eax, DATA
   mov [edi].hButtonDown, eax
   pop eax
   
   ReleaseObject edi
   ret
CBBu_sethButtonDown_Funct  ENDP

; --=====================================================================================--
; sethButtonUp METHOD BEHAVIOR
; --=====================================================================================--
CBBu_sethButtonUp_Funct  PROC uses edi lpTHIS:DWORD, DATA:DWORD
   SetObject edi, CBButton

   mov eax, [edi].hButtonUp
   push eax
   mov eax, DATA
   mov [edi].hButtonUp, eax
   pop eax

   ReleaseObject edi
   ret
CBBu_sethButtonUp_Funct  ENDP

endif